import { ɵɵdefineInjectable, Injectable, Component, EventEmitter, Directive, ElementRef, NgZone, Inject, PLATFORM_ID, Input, Output, ContentChild, TemplateRef, ContentChildren, InjectionToken, ViewChild, Pipe, NgModule } from '@angular/core';
import { isPlatformBrowser, Location, CommonModule } from '@angular/common';
import { Router, NavigationStart, ActivatedRoute, RouterModule } from '@angular/router';
import { filter, map, debounceTime, distinctUntilChanged } from 'rxjs/operators';
import { AuthService, IndiceAuthModule } from 'indice-auth';
import { fromEvent } from 'rxjs';

class IndiceComponentsService {
    constructor() { }
}
IndiceComponentsService.ɵprov = ɵɵdefineInjectable({ factory: function IndiceComponentsService_Factory() { return new IndiceComponentsService(); }, token: IndiceComponentsService, providedIn: "root" });
IndiceComponentsService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
IndiceComponentsService.ctorParameters = () => [];

class IndiceComponentsComponent {
    constructor() { }
    ngOnInit() {
    }
}
IndiceComponentsComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-indice-components',
                template: `
    <p>
      indice-components works!
    </p>
  `
            },] }
];
IndiceComponentsComponent.ctorParameters = () => [];

//
// tslint:disable-next-line:directive-selector
class ClickOutsideDirective {
    constructor(
    // tslint:disable-next-line:variable-name
    _el, 
    // tslint:disable-next-line:variable-name
    _ngZone, platformId) {
        this._el = _el;
        this._ngZone = _ngZone;
        this.platformId = platformId;
        this.clickOutsideEnabled = true;
        this.attachOutsideOnClick = false;
        this.delayClickOutsideInit = false;
        this.emitOnBlur = false;
        this.exclude = '';
        this.excludeBeforeClick = false;
        this.clickOutsideEvents = '';
        this.clickOutside = new EventEmitter();
        // tslint:disable-next-line:variable-name
        this._nodesExcluded = [];
        // tslint:disable-next-line:variable-name
        this._events = ['click'];
        this._initOnClickBody = this._initOnClickBody.bind(this);
        this._onClickBody = this._onClickBody.bind(this);
        this._onWindowBlur = this._onWindowBlur.bind(this);
    }
    ngOnInit() {
        if (!isPlatformBrowser(this.platformId)) {
            return;
        }
        this._init();
    }
    ngOnDestroy() {
        if (!isPlatformBrowser(this.platformId)) {
            return;
        }
        this._removeClickOutsideListener();
        this._removeAttachOutsideOnClickListener();
        this._removeWindowBlurListener();
    }
    ngOnChanges(changes) {
        if (!isPlatformBrowser(this.platformId)) {
            return;
        }
        // tslint:disable-next-line:no-string-literal
        if (changes['attachOutsideOnClick'] || changes['exclude'] || changes['emitOnBlur']) {
            this._init();
        }
    }
    _init() {
        if (this.clickOutsideEvents !== '') {
            this._events = this.clickOutsideEvents.split(',').map(e => e.trim());
        }
        this._excludeCheck();
        if (this.attachOutsideOnClick) {
            this._initAttachOutsideOnClickListener();
        }
        else {
            this._initOnClickBody();
        }
        if (this.emitOnBlur) {
            this._initWindowBlurListener();
        }
    }
    _initOnClickBody() {
        if (this.delayClickOutsideInit) {
            setTimeout(this._initClickOutsideListener.bind(this));
        }
        else {
            this._initClickOutsideListener();
        }
    }
    _excludeCheck() {
        if (this.exclude) {
            try {
                const nodes = Array.from(document.querySelectorAll(this.exclude));
                if (nodes) {
                    this._nodesExcluded = nodes;
                }
            }
            catch (err) {
                console.error('[ng-click-outside] Check your exclude selector syntax.', err);
            }
        }
    }
    _onClickBody(ev) {
        if (!this.clickOutsideEnabled) {
            return;
        }
        if (this.excludeBeforeClick) {
            this._excludeCheck();
        }
        if (!this._el.nativeElement.contains(ev.target) && !this._shouldExclude(ev.target)) {
            this._emit(ev);
            if (this.attachOutsideOnClick) {
                this._removeClickOutsideListener();
            }
        }
    }
    /**
     * Resolves problem with outside click on iframe
     * @see https://github.com/arkon/ng-click-outside/issues/32
     */
    _onWindowBlur(ev) {
        setTimeout(() => {
            if (!document.hidden) {
                this._emit(ev);
            }
        });
    }
    _emit(ev) {
        if (!this.clickOutsideEnabled) {
            return;
        }
        this._ngZone.run(() => this.clickOutside.emit(ev));
    }
    _shouldExclude(target) {
        // tslint:disable-next-line:prefer-const
        for (let excludedNode of this._nodesExcluded) {
            if (excludedNode.contains(target)) {
                return true;
            }
        }
        return false;
    }
    _initClickOutsideListener() {
        this._ngZone.runOutsideAngular(() => {
            this._events.forEach(e => document.addEventListener(e, this._onClickBody));
        });
    }
    _removeClickOutsideListener() {
        this._ngZone.runOutsideAngular(() => {
            this._events.forEach(e => document.removeEventListener(e, this._onClickBody));
        });
    }
    _initAttachOutsideOnClickListener() {
        this._ngZone.runOutsideAngular(() => {
            this._events.forEach(e => this._el.nativeElement.addEventListener(e, this._initOnClickBody));
        });
    }
    _removeAttachOutsideOnClickListener() {
        this._ngZone.runOutsideAngular(() => {
            this._events.forEach(e => this._el.nativeElement.removeEventListener(e, this._initOnClickBody));
        });
    }
    _initWindowBlurListener() {
        this._ngZone.runOutsideAngular(() => {
            window.addEventListener('blur', this._onWindowBlur);
        });
    }
    _removeWindowBlurListener() {
        this._ngZone.runOutsideAngular(() => {
            window.removeEventListener('blur', this._onWindowBlur);
        });
    }
}
ClickOutsideDirective.decorators = [
    { type: Directive, args: [{ selector: '[clickOutside]' },] }
];
ClickOutsideDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: NgZone },
    { type: undefined, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] }
];
ClickOutsideDirective.propDecorators = {
    clickOutsideEnabled: [{ type: Input }],
    attachOutsideOnClick: [{ type: Input }],
    delayClickOutsideInit: [{ type: Input }],
    emitOnBlur: [{ type: Input }],
    exclude: [{ type: Input }],
    excludeBeforeClick: [{ type: Input }],
    clickOutsideEvents: [{ type: Input }],
    clickOutside: [{ type: Output }]
};

class DropDownMenuComponent {
    constructor() {
        this.options = [];
        // tslint:disable-next-line:no-input-rename
        this.selectedValue = null;
        this.selectedOption$ = null;
        this.selectedChanged = new EventEmitter();
        this.expanded$ = false;
    }
    get selectedOption() {
        return this.selectedOption$;
    }
    set selectedOption(option) {
        this.selectedOption$ = option;
        this.selectedValue = option ? option.value : null;
        this.expanded = false;
    }
    get expanded() {
        return this.expanded$;
    }
    set expanded(value) {
        this.expanded$ = value;
    }
    ngOnChanges(changes) {
        if (this.options && this.options.length > 0 && this.selectedValue) {
            this.selectedOption$ = this.options.filter(o => o.value == this.selectedValue)[0];
        }
    }
    ngOnInit() {
    }
    isSelected(option) {
        return option != null && this.selectedValue != null && option.value == this.selectedValue;
    }
    onClickOutside($event) {
        this.expanded = false;
    }
    selectOption(option) {
        this.selectedOption = option;
        this.selectedChanged.emit(option.value);
    }
}
DropDownMenuComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-drop-down-menu',
                template: "<div class=\"relative w-auto\" (clickOutside)=\"onClickOutside($event)\">\r\n  <button type=\"button\" (click)=\"expanded=!expanded\"\r\n          class=\"bg-white relative w-full border border-gray-300 rounded-sm shadow-sm pl-3 pr-10 py-2 text-left cursor-default\r\n          focus:outline-none focus:border-gray-500 sm:text-sm\"\r\n          aria-haspopup=\"listbox\" aria-expanded=\"true\" aria-labelledby=\"listbox-label\">\r\n    <span class=\"block truncate\">\r\n      {{selectedOption?.text}}\r\n    </span>\r\n    <span class=\"absolute inset-y-0 right-0 flex items-center pr-2 pointer-events-none\">\r\n      <!-- Heroicon name: solid/selector -->\r\n      <svg class=\"h-5 w-5 text-gray-400\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 20 20\" fill=\"currentColor\" aria-hidden=\"true\">\r\n        <path fill-rule=\"evenodd\" d=\"M10 3a1 1 0 01.707.293l3 3a1 1 0 01-1.414 1.414L10 5.414 7.707 7.707a1 1 0 01-1.414-1.414l3-3A1 1 0 0110 3zm-3.707 9.293a1 1 0 011.414 0L10 14.586l2.293-2.293a1 1 0 011.414 1.414l-3 3a1 1 0 01-1.414 0l-3-3a1 1 0 010-1.414z\" clip-rule=\"evenodd\" />\r\n      </svg>\r\n    </span>\r\n  </button>\r\n  <ul *ngIf=\"expanded && options && options.length>0\"\r\n      class=\"absolute z-10 mt-1 w-auto bg-white shadow-lg max-h-60 rounded-sm py-1 text-base ring-1 ring-black ring-opacity-5 overflow-auto focus:outline-none sm:text-sm\" tabindex=\"-1\"\r\n      role=\"listbox\" aria-labelledby=\"listbox-label\" aria-activedescendant=\"listbox-option-3\">\r\n      <ng-container *ngFor=\"let option of options\">\r\n        <li [class]=\"isSelected(option) ? 'text-gray-900 cursor-default select-none relative py-2 pl-3 pr-9' : 'text-gray-900 cursor-default select-none relative py-2 pl-3 pr-9 hover:bg-gray-100'\" (click)=\"selectOption(option)\" id=\"listbox-option-0\" role=\"option\">\r\n          <span [class]=\"isSelected(option) ? 'font-semibold block truncate' : 'font-normal block truncate'\">\r\n            {{option.text}}\r\n          </span>\r\n          <span *ngIf=\"isSelected(option)\" class=\"text-gray-600 absolute inset-y-0 right-0 flex items-center pr-4\">\r\n            <!-- Heroicon name: solid/check -->\r\n            <svg class=\"h-5 w-5\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 20 20\" fill=\"currentColor\" aria-hidden=\"true\">\r\n              <path fill-rule=\"evenodd\" d=\"M16.707 5.293a1 1 0 010 1.414l-8 8a1 1 0 01-1.414 0l-4-4a1 1 0 011.414-1.414L8 12.586l7.293-7.293a1 1 0 011.414 0z\" clip-rule=\"evenodd\" />\r\n            </svg>\r\n          </span>\r\n        </li>\r\n      </ng-container>\r\n  </ul>\r\n</div>\r\n"
            },] }
];
DropDownMenuComponent.ctorParameters = () => [];
DropDownMenuComponent.propDecorators = {
    options: [{ type: Input }],
    selectedValue: [{ type: Input, args: ['selected',] }],
    selectedChanged: [{ type: Output }]
};

class Icons {
}
Icons.Dashboard = `ms-Icon ms-Icon--HomeGroup `;
Icons.Locations = `ms-Icon ms-Icon--MapPin `;
Icons.ChargePoints = `ms-Icon ms-Icon--ChatBot `;
Icons.Transations = `ms-Icon ms-Icon--PaymentCard `;
Icons.Badges = `ms-Icon ms-Icon--IDBadge `;
Icons.Refresh = `ms-Icon ms-Icon--Refresh`;
Icons.Search = `ms-Icon ms-Icon--Search`;
Icons.Add = `ms-Icon ms-Icon--Add`;
Icons.Filter = `ms-Icon ms-Icon--Filter`;
Icons.TilesView = `ms-Icon ms-Icon--AppIconDefault`;
Icons.TableView = `ms-Icon ms-Icon--Table`;
Icons.MapView = `ms-Icon ms-Icon--MapPin`;
Icons.Separator = `ms-Icon ms-Icon--Separator text-white`;
Icons.ItemsCount = 'ms-Icon ms-Icon--Boards';
Icons.Heart = 'ms-Icon ms-Icon--Heart';
Icons.HeartBroken = 'ms-Icon ms-Icon--HeartBroken';
Icons.DateTime = 'ms-Icon ms-Icon--ReminderTime';
Icons.SortAsc = 'ms-Icon ms-Icon--Ascending';
Icons.SortDesc = 'ms-Icon ms-Icon--Descending';

class NavLink {
    constructor(text, path, exact = false, external = false, icon) {
        this.text = text;
        this.path = path;
        this.exact = exact;
        this.external = external;
        this.icon = icon;
    }
}
class ExternalNavLink extends NavLink {
    constructor(text, path, icon) {
        super(text, path, true, true, icon);
    }
}
class ViewAction {
    constructor(type, key, param, icon, tooltip) {
        this.type = type;
        this.key = key;
        this.param = param;
        this.icon = icon;
        this.tooltip = tooltip;
    }
}
class RouterViewAction extends ViewAction {
    constructor(icon, link, outlet, tooltip) {
        super('router-link', null, null, icon, tooltip);
        this.outlet = null;
        this.link = null;
        this.outlet = outlet;
        this.link = link;
    }
}
class SwitchViewAction extends ViewAction {
    constructor(view, icon, tooltip) {
        super('switch-view', null, view, icon, tooltip);
    }
}
class HeaderMetaItem {
    constructor() {
        this.key = null;
        this.icon = null;
        this.text = null;
    }
}
class MenuOption {
    constructor(text, value) {
        this.text = text;
        this.value = value;
    }
}

class PagerComponent {
    constructor(router) {
        this.router = router;
        // PAGING
        this.count = null;
        this.page = 1;
        // tslint:disable-next-line:no-input-rename
        this.pageSize = 20;
        // tslint:disable-next-line:no-input-rename
        this.pageSizeOptions = [
            new MenuOption('10', 10),
            new MenuOption('20', 20),
            new MenuOption('30', 30),
            new MenuOption('50', 50),
            new MenuOption('100', 100)
        ];
        this.pages = [];
        this.pageChanged = new EventEmitter();
        this.pageSizeChanged = new EventEmitter();
        this.canPreviousPage = false;
        this.canNextPage = false;
        // SORTING
        // tslint:disable-next-line:no-input-rename
        this.sortOptions = [];
        // tslint:disable-next-line:no-input-rename
        this.sort = null;
        // tslint:disable-next-line:no-input-rename
        this.sortdir = '-';
        this.sortChanged = new EventEmitter();
        this.sortdirChanged = new EventEmitter();
        this.sortdirIcon = Icons.SortDesc;
    }
    ngOnChanges(changes) {
        this.calcPages();
    }
    ngOnInit() {
    }
    calcPages() {
        this.pages = [];
        if (this.count && this.count > 0) {
            const pageCount = this.count / this.pageSize;
            for (let i = 0; i < pageCount; i++) {
                this.pages.push(new MenuOption(i + 1 + '', i + 1));
            }
        }
        this.canPreviousPage = this.page > 1;
        this.canNextPage = this.page < this.pages.length;
        console.log('calcPages', this.page, this.canPreviousPage, this.canNextPage);
    }
    nextPage() {
        const next = this.page + 1;
        this.gotoPage(next);
    }
    previousPage() {
        const previous = this.page - 1;
        this.gotoPage(previous);
    }
    gotoPage(page) {
        this.page = page;
        this.pageChanged.emit(page);
        this.calcPages();
    }
    pageSizeOptionChanged(pageSize) {
        this.pageSizeChanged.emit(pageSize);
        this.calcPages();
    }
    pageOptionChanged(page) {
        this.pageChanged.emit(page);
        this.calcPages();
    }
    sortOptionChanged(sort) {
        this.sortChanged.emit(sort);
    }
    toggleSortdir() {
        console.log('toggleSortdir');
        let sortdir = '-';
        if (this.sortdir == '-') {
            sortdir = '+';
            this.sortdirIcon = Icons.SortAsc;
        }
        else {
            sortdir = '-';
            this.sortdirIcon = Icons.SortDesc;
        }
        this.sortdirChanged.emit(sortdir);
    }
}
PagerComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-pager',
                template: "<!-- This example requires Tailwind CSS v2.0+ -->\r\n<div class=\"flex items-center justify-between mb-2 sm:mb-4\">\r\n  <!--<div class=\"flex-1 px-4 flex justify-between sm:hidden\">\r\n    <a href=\"#\" class=\"relative inline-flex items-center px-4 py-2 border border-gray-300 text-sm font-medium rounded-md text-gray-700 bg-white hover:text-gray-500\">\r\n      Previous\r\n    </a>\r\n    <a href=\"#\" class=\"ml-3 relative inline-flex items-center px-4 py-2 border border-gray-300 text-sm font-medium rounded-md text-gray-700 bg-white hover:text-gray-500\">\r\n      Next\r\n    </a>\r\n  </div>-->\r\n  <div class=\"sm:flex-1 sm:flex sm:items-center sm:justify-between\">\r\n    <div class=\"inline-flex\" *ngIf=\"sortOptions && sortOptions.length > 0\">\r\n      <lib-drop-down-menu [options]=\"sortOptions\" [selected]=\"sort\" (selectedChanged)=\"sortOptionChanged($event)\"></lib-drop-down-menu>\r\n      <button (click)=\"toggleSortdir()\" class=\"inline-flex relative ml-2 inline-flex items-center px-2 py-2 rounded-l-sm border border-gray-300 bg-white text-sm font-medium text-gray-500 hover:bg-gray-50\">\r\n        <span class=\"sr-only\">sort direction</span>\r\n        <span class=\"inline-block relative\">\r\n          <i [class]=\"sortdirIcon\"></i>\r\n        </span>\r\n      </button>\r\n    </div>\r\n    <div class=\"relative z-0 inline-flex rounded-sm\">\r\n      <lib-drop-down-menu [options]=\"pageSizeOptions\" [selected]=\"pageSize\" (selectedChanged)=\"pageSizeOptionChanged($event)\"></lib-drop-down-menu>\r\n      <div class=\"mx-2\">\r\n        <button [disabled]=\"!canPreviousPage\"  (click)=\"previousPage()\"\r\n                class=\"relative ml-2 inline-flex items-center px-2 py-2 rounded-l-sm border border-gray-300 bg-white text-sm font-medium text-gray-500 hover:bg-gray-50\">\r\n          <span class=\"sr-only\">Previous</span>\r\n          <svg class=\"h-5 w-5\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 20 20\" fill=\"currentColor\" aria-hidden=\"true\">\r\n            <path fill-rule=\"evenodd\" d=\"M12.707 5.293a1 1 0 010 1.414L9.414 10l3.293 3.293a1 1 0 01-1.414 1.414l-4-4a1 1 0 010-1.414l4-4a1 1 0 011.414 0z\" clip-rule=\"evenodd\" />\r\n          </svg>\r\n        </button>\r\n        <button [disabled]=\"!canNextPage\"  (click)=\"nextPage()\"\r\n                class=\"relative mr-2 inline-flex items-center px-2 py-2 rounded-r-sm border border-gray-300 bg-white text-sm font-medium text-gray-500 hover:bg-gray-50\">\r\n          <span class=\"sr-only\">Next</span>\r\n          <svg class=\"h-5 w-5\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 20 20\" fill=\"currentColor\" aria-hidden=\"true\">\r\n            <path fill-rule=\"evenodd\" d=\"M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z\" clip-rule=\"evenodd\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n      <lib-drop-down-menu *ngIf=\"pages && pages.length > 0\" [options]=\"pages\" [selected]=\"page\" (selectedChanged)=\"pageOptionChanged($event)\"></lib-drop-down-menu>\r\n    </div>\r\n  </div>\r\n</div>\r\n"
            },] }
];
PagerComponent.ctorParameters = () => [
    { type: Router }
];
PagerComponent.propDecorators = {
    count: [{ type: Input }],
    page: [{ type: Input }],
    pageSize: [{ type: Input, args: ['page-size',] }],
    pageSizeOptions: [{ type: Input, args: ['page-size-options',] }],
    pageChanged: [{ type: Output }],
    pageSizeChanged: [{ type: Output }],
    sortOptions: [{ type: Input, args: ['sort-options',] }],
    sort: [{ type: Input, args: ['sort',] }],
    sortdir: [{ type: Input, args: ['sort-dir',] }],
    sortChanged: [{ type: Output }],
    sortdirChanged: [{ type: Output }]
};

class ListTileComponent {
    constructor() {
        this.model = null;
    }
}
ListTileComponent.decorators = [
    { type: Component, args: [{ template: '<ng-content></ng-content>' },] }
];
ListTileComponent.ctorParameters = () => [];
ListTileComponent.propDecorators = {
    model: [{ type: Input }]
};

class ListColumnComponent {
    constructor() {
        this.title = null;
        this.template = null;
    }
    ngOnInit() {
    }
}
ListColumnComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-list-column',
                template: '<ng-content></ng-content>'
            },] }
];
ListColumnComponent.ctorParameters = () => [];
ListColumnComponent.propDecorators = {
    title: [{ type: Input }],
    template: [{ type: ContentChild, args: [TemplateRef,] }]
};

class ListViewComponent {
    constructor() {
        // PAGING - pass through for pager component
        this.count = null;
        this.page = 1;
        // tslint:disable-next-line:no-input-rename
        this.pageSize = 20;
        // tslint:disable-next-line:no-input-rename
        this.pageSizeOptions = null;
        this.pageChanged = new EventEmitter();
        this.pageSizeChanged = new EventEmitter();
        // SORTING - pass through for pager component
        // tslint:disable-next-line:no-input-rename
        this.sortOptions = [];
        // tslint:disable-next-line:no-input-rename
        this.sort = null;
        // tslint:disable-next-line:no-input-rename
        this.sortdir = '-';
        this.sortChanged = new EventEmitter();
        this.sortdirChanged = new EventEmitter();
        // COLUMNS
        this.columns = [];
        this.cols$ = null;
        this.tile = null;
        this.tiles$ = null;
    }
    set cols(refs) {
        this.cols$ = refs;
        this.columns = this.cols$.toArray();
    }
    set tiles(refs) {
        this.tiles$ = refs;
        this.tile = this.tiles$.toArray()[0];
    }
    ngOnInit() {
    }
    emitPageChanged($event) {
        this.pageChanged.emit($event);
    }
    emitPageSizeChanged($event) {
        this.pageSizeChanged.emit($event);
    }
    emitSortChanged($event) {
        this.sortChanged.emit($event);
    }
    emitSortdirChanged($event) {
        this.sortdirChanged.emit($event);
    }
}
ListViewComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-list-view',
                template: "<div class=\"px-2\">\r\n\r\n  <lib-pager [page]=\"page\"\r\n             [page-size]=\"pageSize\"\r\n             [count]=\"count\"\r\n             [sort-options]=\"sortOptions\"\r\n             [sort]=\"sort\"\r\n             [sort-dir]=\"sortdir\"\r\n             (pageChanged)=\"emitPageChanged($event)\"\r\n             (pageSizeChanged)=\"emitPageSizeChanged($event)\"\r\n             (sortChanged)=\"emitSortChanged($event)\"\r\n             (sortdirChanged)=\"emitSortdirChanged($event)\">\r\n  </lib-pager>\r\n</div>\r\n\r\n<lib-skeleton-loader *ngIf=\"!items\" [count]=\"5\" [type]=\"'table-rows'\"></lib-skeleton-loader>\r\n\r\n<div class=\"flex flex-col border border-gray-200\" *ngIf=\"items\">\r\n  <div class=\"overflow-hidden\">\r\n    <table class=\"min-w-full divide-y divide-gray-200\">\r\n      <thead class=\"bg-gray-50\">\r\n        <tr>\r\n          <th *ngFor=\"let col of columns\" scope=\"col\" class=\"px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider\">\r\n            {{col.title}}\r\n          </th>\r\n        </tr>\r\n      </thead>\r\n      <tbody class=\"bg-white divide-y divide-gray-200\">\r\n        <tr *ngFor=\"let item of items\" class=\"hover:bg-gray-50 hover:py-6\">\r\n          <td *ngFor=\"let col of columns\" class=\"px-6 py-4 whitespace-nowrap\">\r\n            <ng-template [ngTemplateOutlet]=\"col.template\" [ngTemplateOutletContext]=\"{ $implicit: item }\"></ng-template>\r\n          </td>\r\n        </tr>\r\n      </tbody>\r\n    </table>\r\n  </div>\r\n</div>\r\n\r\n<ng-content></ng-content>\r\n"
            },] }
];
ListViewComponent.ctorParameters = () => [];
ListViewComponent.propDecorators = {
    count: [{ type: Input }],
    page: [{ type: Input }],
    pageSize: [{ type: Input, args: ['page-size',] }],
    pageSizeOptions: [{ type: Input, args: ['page-size-options',] }],
    pageChanged: [{ type: Output }],
    pageSizeChanged: [{ type: Output }],
    sortOptions: [{ type: Input, args: ['sort-options',] }],
    sort: [{ type: Input, args: ['sort',] }],
    sortdir: [{ type: Input, args: ['sort-dir',] }],
    sortChanged: [{ type: Output }],
    sortdirChanged: [{ type: Output }],
    items: [{ type: Input }],
    cols: [{ type: ContentChildren, args: [ListColumnComponent, { read: ListColumnComponent },] }],
    tiles: [{ type: ContentChild, args: [ListTileComponent, { read: ListTileComponent },] }]
};

class SkeletonLoaderComponent {
    constructor() {
        this.count = 5;
        this.type = 'small-tile'; // 'large-tile', 'table-rows'
    }
    ngOnInit() {
    }
    counter(i) {
        return new Array(i);
    }
}
SkeletonLoaderComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-skeleton-loader',
                template: "<ng-container *ngSwitch=\"type\">\r\n  <div class=\"cards-deck-4\" *ngSwitchCase=\"'small-tile'\">\r\n    <ng-container *ngFor=\"let i of counter(count)\">\r\n      <div class=\"border border-light-blue-300 shadow rounded-sm p-4 max-w-sm w-full mx-auto\">\r\n        <div class=\"animate-pulse flex space-x-4\">\r\n          <div class=\"rounded-full bg-light-blue-400 h-12 w-12\">&nbsp;</div>\r\n          <div class=\"flex-1 space-y-4 py-1\">\r\n            <div class=\"h-4 bg-light-blue-400 rounded w-3/4\">&nbsp;</div>\r\n            <div class=\"space-y-2\">\r\n              <div class=\"h-4 bg-light-blue-400 rounded\">&nbsp;</div>\r\n              <div class=\"h-4 bg-light-blue-400 rounded w-5/6\">&nbsp;</div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"cards-deck-3\" *ngSwitchCase=\"'large-tile'\">\r\n    <ng-container *ngFor=\"let i of counter(count)\">\r\n      <div class=\"border border-light-blue-300 shadow rounded-sm p-4 max-w-sm w-full mx-auto\">\r\n        <div class=\"animate-pulse flex space-x-4\">\r\n          <div class=\"rounded-full bg-light-blue-400 h-12 w-12\">&nbsp;</div>\r\n          <div class=\"rounded-full bg-light-blue-400 h-12 w-12\">&nbsp;</div>\r\n          <div class=\"rounded-full bg-light-blue-400 h-12 w-12\">&nbsp;</div>\r\n          <div class=\"flex-1 space-y-4 py-1\">\r\n            <div class=\"h-4 bg-light-blue-400 rounded w-3/4\">&nbsp;</div>\r\n            <div class=\"space-y-2\">\r\n              <div class=\"h-4 bg-light-blue-400 rounded\">&nbsp;</div>\r\n              <div class=\"h-4 bg-light-blue-400 rounded w-5/6\">&nbsp;</div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n  <div class=\"cards-deck-1\" *ngSwitchCase=\"'table-rows'\">\r\n    <ng-container *ngFor=\"let i of counter(count)\">\r\n      <div class=\"border border-light-blue-300 shadow rounded-sm p-4 max-w-sm w-full mx-auto mb-4\">\r\n        <div class=\"animate-pulse flex space-x-4\">\r\n          <div class=\"rounded-full bg-light-blue-400 h-12 w-12\">&nbsp;</div>\r\n          <div class=\"flex-1 space-y-4 py-1\">\r\n            <div class=\"h-4 bg-light-blue-400 rounded w-3/4\">&nbsp;</div>\r\n            <div class=\"space-y-2\">\r\n              <div class=\"h-4 bg-light-blue-400 rounded\">&nbsp;</div>\r\n              <div class=\"h-4 bg-light-blue-400 rounded w-5/6\">&nbsp;</div>\r\n            </div>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </ng-container>\r\n  </div>\r\n</ng-container>\r\n"
            },] }
];
SkeletonLoaderComponent.ctorParameters = () => [];
SkeletonLoaderComponent.propDecorators = {
    count: [{ type: Input }],
    type: [{ type: Input }]
};

class ShellLayoutComponent {
    constructor(router, location) {
        this.router = router;
        this.location = location;
        this.showRightPaneSM = false;
    }
    ngOnInit() {
    }
    onSidePaneActivated($event) {
        console.log('onSidePaneActivated', $event);
        this.showRightPaneSM = true;
    }
    onSidePaneDeactivated($event) {
        console.log('onSidePaneActivated', $event);
        this.showRightPaneSM = false;
    }
    closeSidePane() {
        this.location.back();
    }
}
ShellLayoutComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-shell-layout',
                template: "<div class=\"shell-container\">\r\n  <div class=\"shell-header-container\">\r\n    <div class=\"shell-header-container-inner\">\r\n      <lib-shell-header></lib-shell-header>\r\n    </div>\r\n  </div>\r\n  <main class=\"shell-content-container\">\r\n    <div class=\"shell-content-container-inner\">\r\n      <router-outlet></router-outlet>\r\n    </div>\r\n  </main>\r\n  <div class=\"shell-footer-container\">\r\n    <div class=\"shell-footer-container-inner\">\r\n      <lib-shell-footer></lib-shell-footer>\r\n    </div>\r\n  </div>\r\n  <div [class]=\"showRightPaneSM ? 'side-pane-overlay' : 'hidden'\" aria-hidden=\"true\"></div>\r\n  <div [class]=\"showRightPaneSM ? 'side-pane-container' : 'hidden'\">\r\n    <div class=\"w-screen max-w-md\">\r\n      <div class=\"side-pane\">\r\n        <router-outlet name=\"rightpane\" (activate)=\"onSidePaneActivated($event)\" (deactivate)=\"onSidePaneDeactivated($event)\"></router-outlet>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n"
            },] }
];
ShellLayoutComponent.ctorParameters = () => [
    { type: Router },
    { type: Location }
];

const APP_LINKS = new InjectionToken('APP_LINKS');

class ShellHeaderComponent {
    constructor(authService, router, links) {
        this.authService = authService;
        this.router = router;
        this.links = links;
        this.mobileMenuExpanded = false;
        this.userMenuExpanded = false;
        this.user = null;
        this.avatarName = null;
    }
    ngOnDestroy() {
        if (this.routerSub$) {
            this.routerSub$.unsubscribe();
        }
        // TODO: check authenticated user here before we start polling server status
        if (this.statusSub$) {
            this.statusSub$.unsubscribe();
        }
        if (this.userSub$) {
            this.userSub$.unsubscribe();
        }
    }
    ngOnInit() {
        this.routerSub$ = this.router.events.pipe(filter(event => event instanceof NavigationStart)).subscribe(event => {
            this.mobileMenuExpanded = false;
            this.userMenuExpanded = false;
        });
        this.authService.loadUser().then(user => {
            this.setCurrentUser(user);
        }, error => {
            console.log(error);
        });
        // Detect user changes and display / or not user info accordingly...
        this.userSub$ = this.authService.userStatus.subscribe((user) => {
            this.setCurrentUser(user);
        });
    }
    // tslint:disable-next-line:typedef
    setCurrentUser(user) {
        var _a, _b;
        this.user = user;
        if (this.user && this.user.profile) {
            this.avatarName = `${(_a = this.user.profile.given_name) === null || _a === void 0 ? void 0 : _a.charAt(0)}${(_b = this.user.profile.family_name) === null || _b === void 0 ? void 0 : _b.charAt(0)}`;
            console.log('load user', this.avatarName);
        }
    }
    // tslint:disable-next-line:typedef
    onClickOutside($event) {
        this.userMenuExpanded = false;
    }
}
ShellHeaderComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-shell-header',
                template: "  <nav>\r\n    <div class=\"shell-header-paddings\">\r\n      <div class=\"shell-header-border\">\r\n        <div class=\"shell-header-menu-container\">\r\n          <div class=\"flex items-center\">\r\n            <div class=\"flex-shrink-0\">\r\n              <a href=\"#\" [routerLink]=\"['/']\"><img class=\"h-8 w-8\" src=\"https://tailwindui.com/img/logos/workflow-mark.svg?color=white\" alt=\"EVPulse\"></a>\r\n            </div>\r\n            <div class=\"md-visible\">\r\n              <div class=\"shell-header-link-container\">\r\n                <ng-container *ngFor=\"let link of links.main\">\r\n                  <a href=\"#\" [routerLinkActive]=\"['nav-link-active']\" [routerLinkActiveOptions]=\"{ exact: link.exact }\" [routerLink]=\"[link.path]\" class=\"nav-link\">\r\n                    {{link.text}}\r\n                  </a>\r\n                </ng-container>\r\n              </div>\r\n            </div>\r\n          </div>\r\n          <div class=\"md-visible\">\r\n            <div class=\"ml-4 flex items-center md:ml-6\">\r\n\r\n              <ng-container *ngFor=\"let link of links.profileActions\">\r\n                <a class=\"shell-header-menu-rounded-button\" (clickOutside)=\"onClickOutside($event)\" href=\"#\" [routerLink]=\"[link.path]\">\r\n                  <span class=\"sr-only\">{{link.text}}</span>\r\n                  <i *ngIf=\"link.icon\" [class]=\"link.icon\"></i>\r\n                </a>\r\n              </ng-container>\r\n\r\n              <!-- Profile dropdown -->\r\n              <div class=\"ml-2 relative\" (clickOutside)=\"onClickOutside($event)\" *ngIf=\"user\">\r\n                <div>\r\n                  <button type=\"button\" (click)=\"userMenuExpanded=!userMenuExpanded\"\r\n                          class=\"shell-header-profile-dropdown-button\"\r\n                          id=\"user-menu\" aria-expanded=\"false\" aria-haspopup=\"true\">\r\n                    <span class=\"sr-only\">Open user menu</span>\r\n                    <span class=\"shell-header-avatar\">\r\n                      <span class=\"shell-header-avatar-name\">{{this.avatarName}}</span>\r\n                    </span>\r\n                  </button>\r\n                </div>\r\n\r\n                <!--\r\n      Dropdown menu, show/hide based on menu state.\r\n      Entering: \"transition ease-out duration-100\"\r\n        From: \"transform opacity-0 scale-95\"\r\n        To: \"transform opacity-100 scale-100\"\r\n      Leaving: \"transition ease-in duration-75\"\r\n        From: \"transform opacity-100 scale-100\"\r\n        To: \"transform opacity-0 scale-95\"\r\n    -->\r\n                <div *ngIf=\"userMenuExpanded\" class=\"shell-header-profile-dropdown\" role=\"menu\" aria-orientation=\"vertical\" aria-labelledby=\"user-menu\">\r\n                  <!-- <a href=\"#\" class=\"block px-4 py-2 text-sm text-gray-700 hover:bg-gray-100\" role=\"menuitem\">\u0391\u03C0\u03BF\u03C3\u03CD\u03BD\u03B4\u03B5\u03C3\u03B7</a> -->\r\n                  <ng-container *ngFor=\"let link of links.profile\">\r\n                    <a href=\"#\" [routerLinkActive]=\"['nav-link-profile-active']\" [routerLinkActiveOptions]=\"{ exact: link.exact }\" [routerLink]=\"[link.path]\" class=\"nav-link-profile\">\r\n                      {{link.text}}\r\n                    </a>\r\n                  </ng-container>\r\n                </div>\r\n              </div>\r\n            </div>\r\n          </div>\r\n          <div class=\"mobile-menu-button-container\">\r\n            <!-- Mobile menu button -->\r\n            <button type=\"button\" (click)=\"mobileMenuExpanded = !mobileMenuExpanded\" class=\"mobile-menu-button\" aria-controls=\"mobile-menu\" aria-expanded=\"false\">\r\n              <span class=\"sr-only\">Open main menu</span>\r\n              <!--Heroicon name: outline/menu  Menu open: \"hidden\", Menu closed: \"block\"-->\r\n              <svg class=\"block h-6 w-6\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke=\"currentColor\" aria-hidden=\"true\">\r\n                <path stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\" d=\"M4 6h16M4 12h16M4 18h16\" />\r\n              </svg>\r\n              <!--Heroicon name: outline/x Menu open: \"block\", Menu closed: \"hidden\"-->\r\n              <svg class=\"hidden h-6 w-6\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke=\"currentColor\" aria-hidden=\"true\">\r\n                <path stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\" d=\"M6 18L18 6M6 6l12 12\" />\r\n              </svg>\r\n            </button>\r\n          </div>\r\n        </div>\r\n      </div>\r\n    </div>\r\n\r\n    <!-- Mobile menu, show/hide based on menu state. -->\r\n    <div class=\"mobile-menu-container\" *ngIf=\"mobileMenuExpanded\" id=\"mobile-menu\">\r\n      <div class=\"mobile-menu-link-container\">\r\n        <ng-container *ngFor=\"let link of links.main\">\r\n          <a href=\"#\" [routerLinkActive]=\"['nav-link-mobile-active']\" [routerLinkActiveOptions]=\"{ exact: link.exact }\" [routerLink]=\"[link.path]\" class=\"nav-link-mobile\">\r\n            {{link.text}}\r\n          </a>\r\n        </ng-container>\r\n      </div>\r\n      <div class=\"mobile-menu-user-info-container\" *ngIf=\"user\" >\r\n        <div class=\"mobile-menu-user-info-container-inner\">\r\n          <div class=\"flex-shrink-0\">\r\n            <span class=\"mobile-menu-avatar-container\">\r\n              <span class=\"mobile-menu-avatar-name\">{{this.avatarName}}</span>\r\n            </span>\r\n          </div>\r\n          <div class=\"ml-3\">\r\n            <div class=\"mobile-menu-user-name\">{{user.profile.name}}</div>\r\n            <div class=\"mobile-menu-user-email\">{{user.profile.email}}</div>\r\n          </div>\r\n          <button class=\"mobile-menu-rounded-button\">\r\n            <span class=\"sr-only\">View notifications</span>\r\n            <!-- Heroicon name: outline/bell -->\r\n            <svg class=\"mobile-menu-rounded-button-icon-style\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke=\"currentColor\" aria-hidden=\"true\">\r\n              <path stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\" d=\"M15 17h5l-1.405-1.405A2.032 2.032 0 0118 14.158V11a6.002 6.002 0 00-4-5.659V5a2 2 0 10-4 0v.341C7.67 6.165 6 8.388 6 11v3.159c0 .538-.214 1.055-.595 1.436L4 17h5m6 0v1a3 3 0 11-6 0v-1m6 0H9\" />\r\n            </svg>\r\n          </button>\r\n        </div>\r\n        <div class=\"mobile-menu-link-container\">\r\n          <ng-container *ngFor=\"let link of links.profile\">\r\n            <a href=\"#\" [routerLinkActive]=\"['nav-link-mobile-active']\" [routerLinkActiveOptions]=\"{ exact: link.exact }\" [routerLink]=\"[link.path]\" class=\"nav-link-mobile\">\r\n              {{link.text}}\r\n            </a>\r\n          </ng-container>\r\n          <!-- <a href=\"#\" class=\"block px-3 py-2 rounded-sm text-base font-medium text-gray-400 hover:text-white hover:bg-gray-700\">\u0391\u03C0\u03BF\u03C3\u03CD\u03BD\u03B4\u03B5\u03C3\u03B7</a> -->\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </nav>\r\n"
            },] }
];
ShellHeaderComponent.ctorParameters = () => [
    { type: AuthService, decorators: [{ type: Inject, args: [AuthService,] }] },
    { type: Router, decorators: [{ type: Inject, args: [Router,] }] },
    { type: undefined, decorators: [{ type: Inject, args: [APP_LINKS,] }] }
];

class ShellFooterComponent {
    constructor(links) {
        this.links = links;
    }
}
ShellFooterComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-shell-footer',
                template: "<footer class=\"text-gray-300 px-6 lg:px-8 py-12\">\r\n  <div class=\"max-w-screen-xl mx-auto \">\r\n    <div class=\"grid grid-cols-8 md:grid-cols-9  lg:grid-cols-8  divide-gray-700 divide-y-2 md:divide-x-2 md:divide-y-0 md:-mx-8\">\r\n      <div class=\"col-span-8 md:col-span-3 lg:col-span-2 md:px-8 py-4 md:py-0\">\r\n        <img class=\"h-12\" src=\"/assets/images/branding/indice.png\" alt=\"INDICE logo\">\r\n        <nav class=\"mt-4\">\r\n          <ul class=\"space-y-2\">\r\n            <ng-container *ngFor=\"let link of links.brand\">\r\n              <li>\r\n                <a [href]=\"link.path\" class=\"font-normal text-base hover:text-gray-100\">{{link.text}}</a>\r\n              </li>\r\n            </ng-container>\r\n          </ul>\r\n        </nav>\r\n      </div>\r\n      <div class=\"col-span-8 md:col-span-3 lg:col-span-3 md:px-8 py-4 md:py-0\">\r\n        <h5 class=\"text-xl font-semibold text-white\">Legal</h5>\r\n        <nav class=\"mt-4\">\r\n          <ul class=\"grid lg:grid-cols-2\">\r\n            <ng-container *ngFor=\"let link of links.legal\">\r\n              <li class=\"mb-2\">\r\n                <a [href]=\"link.path\" class=\"font-normal text-base hover:text-gray-100\">{{link.text}}</a>\r\n              </li>\r\n            </ng-container>\r\n          </ul>\r\n        </nav>\r\n      </div>\r\n      <div class=\"col-span-8 md:col-span-3 lg:col-span-3 md:px-8 py-4 md:py-0\">\r\n        <h5 class=\"text-xl font-semibold text-white\">Follow us</h5>\r\n        <nav class=\"mt-4\">\r\n          <ul class=\"grid lg:grid-cols-2\">\r\n            <li class=\"mb-2\">\r\n              <a href=\"#\" class=\"flex space-x-2 font-normal text-base hover:text-gray-100\">\r\n                <svg class=\"h-6 w-6\" aria-hidden=\"true\" fill=\"currentColor\" viewBox=\"0 0 24 24\">\r\n                  <path d=\"M8.29 20.251c7.547 0 11.675-6.253 11.675-11.675 0-.178 0-.355-.012-.53A8.348 8.348 0 0022 5.92a8.19 8.19 0 01-2.357.646 4.118 4.118 0 001.804-2.27 8.224 8.224 0 01-2.605.996 4.107 4.107 0 00-6.993 3.743 11.65 11.65 0 01-8.457-4.287 4.106 4.106 0 001.27 5.477A4.072 4.072 0 012.8 9.713v.052a4.105 4.105 0 003.292 4.022 4.095 4.095 0 01-1.853.07 4.108 4.108 0 003.834 2.85A8.233 8.233 0 012 18.407a11.616 11.616 0 006.29 1.84\" />\r\n                </svg>\r\n                <span>\r\n                  Twitter\r\n                </span>\r\n              </a>\r\n            </li>\r\n            <li class=\"mb-2\">\r\n              <a href=\"#\" class=\"flex space-x-2  font-normal text-base hover:text-gray-100\">\r\n                <svg class=\"h-6 w-6\" aria-hidden=\"true\" fill=\"currentColor\" viewBox=\"0 0 24 24\">\r\n                  <path fill-rule=\"evenodd\" d=\"M12.315 2c2.43 0 2.784.013 3.808.06 1.064.049 1.791.218 2.427.465a4.902 4.902 0 011.772 1.153 4.902 4.902 0 011.153 1.772c.247.636.416 1.363.465 2.427.048 1.067.06 1.407.06 4.123v.08c0 2.643-.012 2.987-.06 4.043-.049 1.064-.218 1.791-.465 2.427a4.902 4.902 0 01-1.153 1.772 4.902 4.902 0 01-1.772 1.153c-.636.247-1.363.416-2.427.465-1.067.048-1.407.06-4.123.06h-.08c-2.643 0-2.987-.012-4.043-.06-1.064-.049-1.791-.218-2.427-.465a4.902 4.902 0 01-1.772-1.153 4.902 4.902 0 01-1.153-1.772c-.247-.636-.416-1.363-.465-2.427-.047-1.024-.06-1.379-.06-3.808v-.63c0-2.43.013-2.784.06-3.808.049-1.064.218-1.791.465-2.427a4.902 4.902 0 011.153-1.772A4.902 4.902 0 015.45 2.525c.636-.247 1.363-.416 2.427-.465C8.901 2.013 9.256 2 11.685 2h.63zm-.081 1.802h-.468c-2.456 0-2.784.011-3.807.058-.975.045-1.504.207-1.857.344-.467.182-.8.398-1.15.748-.35.35-.566.683-.748 1.15-.137.353-.3.882-.344 1.857-.047 1.023-.058 1.351-.058 3.807v.468c0 2.456.011 2.784.058 3.807.045.975.207 1.504.344 1.857.182.466.399.8.748 1.15.35.35.683.566 1.15.748.353.137.882.3 1.857.344 1.054.048 1.37.058 4.041.058h.08c2.597 0 2.917-.01 3.96-.058.976-.045 1.505-.207 1.858-.344.466-.182.8-.398 1.15-.748.35-.35.566-.683.748-1.15.137-.353.3-.882.344-1.857.048-1.055.058-1.37.058-4.041v-.08c0-2.597-.01-2.917-.058-3.96-.045-.976-.207-1.505-.344-1.858a3.097 3.097 0 00-.748-1.15 3.098 3.098 0 00-1.15-.748c-.353-.137-.882-.3-1.857-.344-1.023-.047-1.351-.058-3.807-.058zM12 6.865a5.135 5.135 0 110 10.27 5.135 5.135 0 010-10.27zm0 1.802a3.333 3.333 0 100 6.666 3.333 3.333 0 000-6.666zm5.338-3.205a1.2 1.2 0 110 2.4 1.2 1.2 0 010-2.4z\" clip-rule=\"evenodd\" />\r\n                </svg>\r\n                <span>\r\n                  Instagram\r\n                </span>\r\n              </a>\r\n            </li>\r\n            <li class=\"mb-2\">\r\n              <a href=\"#\" class=\"flex space-x-2  font-normal text-base hover:text-gray-100\">\r\n                <svg class=\"h-6 w-6\" aria-hidden=\"true\" fill=\"currentColor\" viewBox=\"0 0 24 24\">\r\n                  <path fill-rule=\"evenodd\" d=\"M22 12c0-5.523-4.477-10-10-10S2 6.477 2 12c0 4.991 3.657 9.128 8.438 9.878v-6.987h-2.54V12h2.54V9.797c0-2.506 1.492-3.89 3.777-3.89 1.094 0 2.238.195 2.238.195v2.46h-1.26c-1.243 0-1.63.771-1.63 1.562V12h2.773l-.443 2.89h-2.33v6.988C18.343 21.128 22 16.991 22 12z\" clip-rule=\"evenodd\" />\r\n                </svg>\r\n                <span>\r\n                  Facebook\r\n                </span>\r\n              </a>\r\n            </li>\r\n          </ul>\r\n        </nav>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"max-w-screen-xl mx-auto flex flex-col md:flex-row justify-between items-center space-y-4 mt-8 lg:mt-12 border-t-2 border-gray-700 pt-8\">\r\n    <!--<nav class=\"flex flex-wrap justify-center space-x-6\">\r\n      <a href=\"#\" class=\"font-normal text-sm hover:text-gray-100 mb-2\">Cookie settings</a>\r\n    </nav>-->\r\n    <p class=\"text-sm text-center sm:text-right\">\u00A9 2021 INDICE. All rights reserved.</p>\r\n  </div>\r\n</footer>\r\n"
            },] }
];
ShellFooterComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [APP_LINKS,] }] }
];

class ViewLayoutComponent {
    constructor(route$, router$) {
        this.route$ = route$;
        this.router$ = router$;
        // tslint:disable-next-line:no-input-rename
        this.header = true;
        this.fluid = false;
        this.title = 'no title';
        this.icon = null;
        this.actions = null;
        this.busy = false;
        // tslint:disable-next-line:no-input-rename
        this.searchPlaceholder = 'αναζήτηση';
        this.view = null;
        // tslint:disable-next-line:no-input-rename
        this.metaItems = [
        // { key: 'test', icon: Icons.Badges, text: 'βρέθηκαν 200 αποτελέσματα' }
        ];
        // tslint:disable-next-line:no-output-on-prefix
        this.onAction = new EventEmitter();
        // tslint:disable-next-line:no-output-on-prefix
        this.onSearch = new EventEmitter();
    }
    ngOnInit() {
    }
    emitActionClick(action) {
        this.onAction.emit(action);
    }
    routerLinkActionClick(action) {
        console.log('routerLinkActionClick', action);
        if (action.outlet) {
            this.router$.navigate(['', { outlets: { rightpane: action.link } }]);
        }
        else {
            this.router$.navigate([action.link]);
        }
    }
    searchActionClick(action, text) {
        this.onSearch.emit(text);
    }
    searchActionType(text) {
        var _a;
        fromEvent((_a = this.searchInput$) === null || _a === void 0 ? void 0 : _a.nativeElement, 'keyup').pipe(map((event) => {
            return event.target.value; // Get input value.
        }), filter(inputValue => inputValue.length >= 3 || inputValue.length === 0), 
        // If character length greater than minimumSearchCharacters setting.
        debounceTime(1000), // Time in milliseconds between key events.
        distinctUntilChanged() // If previous query is different from current.
        ).subscribe(_ => {
            var _a;
            this.onSearch.emit((_a = this.searchInput$) === null || _a === void 0 ? void 0 : _a.nativeElement.value);
        });
    }
    switchViewActionClick(action) {
        console.log('switchViewActionClick', action);
        this.view = action.param;
        if (action && action.param) {
            this.router$.navigate([], { queryParams: { view: action.param }, queryParamsHandling: 'merge', skipLocationChange: false });
        }
    }
}
ViewLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-view-layout',
                template: "<header *ngIf=\"header\" class=\"view-layout-paddings\">\r\n\r\n  <div class=\"view-layout-title-container\">\r\n    <div class=\"flex-1 justify-start items-center\">\r\n      <i *ngIf=\"icon\"\r\n         [class]=\"icon + ' text-xl text-white font-thin mr-1'\"\r\n         aria-hidden=\"true\"></i>\r\n      <h1 [class]=\"busy ? 'animate-pulse inline text-xl text-gray-200' : 'inline text-xl text-white'\">\r\n        {{title}}\r\n      </h1>\r\n    </div>\r\n    <div *ngIf=\"metaItems && metaItems.length > 0\"\r\n         class=\"flex flex-2 space-x-2\">\r\n      <ng-container *ngFor=\"let meta of metaItems\">\r\n        <div class=\"mt-2 flex items-center text-xs text-gray-500\">\r\n          <i *ngIf=\"meta.icon\"\r\n             [class]=\"meta.icon + ' text-sm text-gray-400 mr-1 sm:mr-2'\"\r\n             aria-hidden=\"true\"></i>\r\n          {{meta.text}}\r\n        </div>\r\n      </ng-container>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"hidden md:flex justify-between items-center\">\r\n    <div class=\"flex-1 justify-start\">\r\n      <i *ngIf=\"icon\"\r\n         [class]=\"icon + ' text-2xl text-white font-thin mr-2 mt-1'\"\r\n         aria-hidden=\"true\"></i>\r\n      <h1 [class]=\"busy ? 'animate-pulse inline text-3xl text-gray-200' : 'inline text-3xl text-white'\">\r\n        {{title}}\r\n      </h1>\r\n      <div *ngIf=\"metaItems && metaItems.length > 0\"\r\n           class=\"flex flex-wrap sm:flex-row space-x-2 sm:space-x-4\">\r\n        <ng-container *ngFor=\"let meta of metaItems\">\r\n          <div class=\"mt-2 flex items-center text-xs text-gray-500\">\r\n            <i *ngIf=\"meta.icon\"\r\n               [class]=\"meta.icon + ' text-sm text-gray-400 mr-1 sm:mr-2'\"\r\n               aria-hidden=\"true\"></i>\r\n            {{meta.text}}\r\n          </div>\r\n        </ng-container>\r\n      </div>\r\n    </div>\r\n\r\n    <div class=\"flex items-center justify-end\">\r\n      <ng-container *ngFor=\"let action of actions\"\r\n                    [ngSwitch]=\"action.type\">\r\n        <ng-container *ngSwitchCase=\"'switch-view'\">\r\n          <button [disabled]=\"view==action.param\"\r\n                  type=\"button\"\r\n                  href=\"#\"\r\n                  class=\"ml-1 disabled:opacity-50 btn-view-header\"\r\n                  (click)=\"switchViewActionClick(action)\">\r\n            <span class=\"inline-block relative\">\r\n              <i [class]=\"action.icon\"></i>\r\n              <span *ngIf=\"view==action.param\"\r\n                    class=\"absolute top-0 right-0 block ml-2 h-1.5 w-1.5 rounded-full ring-1 ring-white bg-blue-300\"></span>\r\n            </span>\r\n          </button>\r\n        </ng-container>\r\n        <ng-container *ngSwitchCase=\"'search'\">\r\n          <label for=\"search\"\r\n                 class=\"sr-only\">Search</label>\r\n          <div class=\"relative text-gray-400 focus-within:text-gray-600 ml-2 hover:shadow-sm hover:bg-gray-900\">\r\n            <div class=\"pointer-events-none absolute inset-y-0 left-0 pl-3 flex items-center\">\r\n              <!--<svg class=\"h-5 w-5\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 20 20\" fill=\"currentColor\" aria-hidden=\"true\">\r\n                <path fill-rule=\"evenodd\" d=\"M8 4a4 4 0 100 8 4 4 0 000-8zM2 8a6 6 0 1110.89 3.476l4.817 4.817a1 1 0 01-1.414 1.414l-4.816-4.816A6 6 0 012 8z\" clip-rule=\"evenodd\" />\r\n              </svg>-->\r\n            </div>\r\n            <input id=\"search\"\r\n                   #search\r\n                   class=\"block w-60 focus:w-96 bg-gray-50 rounded-sm text-gray-900 placeholder-gray-500 outline-none text-xs\"\r\n                   [placeholder]=\"searchPlaceholder\"\r\n                   type=\"search\"\r\n                   name=\"search\"\r\n                   (input)=\"searchActionType(search.value)\">\r\n          </div>\r\n          <button type=\"button\"\r\n                  href=\"#\"\r\n                  class=\"btn-view-header rounded-l-none\"\r\n                  (click)=\"searchActionClick(action, search.value)\">\r\n            <i [class]=\"action.icon\"></i>\r\n          </button>\r\n        </ng-container>\r\n        <ng-container *ngSwitchCase=\"'router-link'\">\r\n          <button type=\"button\"\r\n                  href=\"#\"\r\n                  class=\"ml-1 btn-view-header\"\r\n                  (click)=\"routerLinkActionClick(action)\">\r\n            <i [class]=\"action.icon\"></i>\r\n          </button>\r\n        </ng-container>\r\n\r\n        <!---->\r\n        <ng-container *ngSwitchDefault>\r\n          <button type=\"button\"\r\n                  class=\"ml-1 btn-view-header\"\r\n                  (click)=\"emitActionClick(action)\">\r\n            <i [class]=\"action.icon\"></i>\r\n          </button>\r\n        </ng-container>\r\n      </ng-container>\r\n    </div>\r\n  </div>\r\n</header>\r\n\r\n<!-- component -->\r\n<div [class]=\"fluid ? 'view-container-fluid' : 'view-container'\">\r\n  <ng-content></ng-content>\r\n</div>\r\n"
            },] }
];
ViewLayoutComponent.ctorParameters = () => [
    { type: ActivatedRoute },
    { type: Router }
];
ViewLayoutComponent.propDecorators = {
    searchInput$: [{ type: ViewChild, args: ['search',] }],
    header: [{ type: Input, args: ['show-header',] }],
    fluid: [{ type: Input }],
    title: [{ type: Input }],
    icon: [{ type: Input }],
    actions: [{ type: Input }],
    busy: [{ type: Input }],
    searchPlaceholder: [{ type: Input, args: ['search-placeholder',] }],
    view: [{ type: Input }],
    metaItems: [{ type: Input, args: ['meta-items',] }],
    onAction: [{ type: Output }],
    onSearch: [{ type: Output }]
};

class ModelViewLayoutComponent {
    constructor() {
        this.title = 'no title';
        // tslint:disable-next-line:no-input-rename
        this.primary = null;
        // tslint:disable-next-line:no-input-rename
        this.secondary = null;
    }
    ngOnInit() {
    }
}
ModelViewLayoutComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-model-view-layout',
                template: "<lib-view-layout [title]=\"title\">\r\n  <main class=\"details-view-container\">\r\n    <div class=\"lg:grid lg:grid-cols-12 lg:gap-x-5\">\r\n      <aside class=\"py-6 px-2 sm:px-6 lg:py-0 lg:px-0 lg:col-span-4 md:col-span-3\">\r\n        <section aria-labelledby=\"menu\" class=\"min-w-full\">\r\n          <div class=\"bg-white shadow rounded-sm\">\r\n            <div class=\"flex flex-col justify-stretch bg-gray-50 border-b\">\r\n              <ng-content></ng-content>\r\n            </div>\r\n            <!-- menu items -->\r\n            <div class=\"mt-2 px-4 py-4 flow-root\">\r\n              <nav class=\"h-full flex flex-col\">\r\n                <div class=\"space-y-1\">\r\n                  <ng-container *ngFor=\"let section of primary\">\r\n                    <a href=\"#\" [routerLinkActive]=\"['view-nav-link-active']\" [routerLink]=\"section.link\" class=\"view-nav-link\">\r\n                      {{section.text}}\r\n                    </a>\r\n                  </ng-container>\r\n                </div>\r\n\r\n                <div class=\"mt-auto pt-10 space-y-1\">\r\n                  <ng-container *ngFor=\"let section of secondary\">\r\n                    <a href=\"#\" [routerLinkActive]=\"['view-nav-link-active']\" [routerLinkActiveOptions]=\"{ exact: true }\"\r\n                       [routerLink]=\"section.link\" class=\"view-nav-link\">\r\n                      {{section.text}}\r\n                    </a>\r\n                  </ng-container>\r\n                </div>\r\n              </nav>\r\n            </div>\r\n          </div>\r\n        </section>\r\n      </aside>\r\n\r\n      <div class=\"space-y-6 sm:px-6 lg:px-0 lg:col-span-8 md:col-span-9\">\r\n        <router-outlet></router-outlet>\r\n      </div>\r\n    </div>\r\n  </main>\r\n\r\n"
            },] }
];
ModelViewLayoutComponent.ctorParameters = () => [];
ModelViewLayoutComponent.propDecorators = {
    title: [{ type: Input }],
    primary: [{ type: Input, args: ['primary-links',] }],
    secondary: [{ type: Input, args: ['secondary-links',] }]
};

class SideViewLayoutComponent {
    constructor(location) {
        this.location = location;
        this.title = 'Πληροφορίες';
    }
    ngOnInit() {
    }
    closeSidePane() {
        this.location.back();
    }
}
SideViewLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-side-view-layout',
                template: "<div class=\"w-full h-full overflow-y-none\">\r\n  <!-- This example requires Tailwind CSS v2.0+ -->\r\n  <div class=\"bg-gray-900 px-4 py-5 border-b border-gray-200 sm:px-6\">\r\n    <div class=\"-ml-4 -mt-2 flex text-white items-center justify-between flex-wrap sm:flex-nowrap\">\r\n      <div class=\"ml-4 mt-2\">\r\n        <h3 class=\"text-lg leading-6 font-medium\">\r\n          {{title}}\r\n        </h3>\r\n      </div>\r\n      <div class=\"ml-4 mt-2 flex-shrink-0\">\r\n        <button (click)=\"closeSidePane()\" class=\"rounded-sm text-gray-400 hover:text-gray-500 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500\">\r\n          <span class=\"sr-only\">Close panel</span>\r\n          <!-- Heroicon name: outline/x -->\r\n          <svg class=\"h-6 w-6\" xmlns=\"http://www.w3.org/2000/svg\" fill=\"none\" viewBox=\"0 0 24 24\" stroke=\"currentColor\" aria-hidden=\"true\">\r\n            <path stroke-linecap=\"round\" stroke-linejoin=\"round\" stroke-width=\"2\" d=\"M6 18L18 6M6 6l12 12\" />\r\n          </svg>\r\n        </button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <div class=\"mt-6 relative px-4 sm:px-6 flex-1 bg-white\">\r\n      <ng-content></ng-content>\r\n  </div>\r\n</div>\r\n"
            },] }
];
SideViewLayoutComponent.ctorParameters = () => [
    { type: Location }
];
SideViewLayoutComponent.propDecorators = {
    title: [{ type: Input }]
};

class FormLayoutComponent {
    constructor() {
        this.title = null;
        // tslint:disable-next-line:no-input-rename
        this.subTitle = null;
    }
    ngOnInit() {
    }
}
FormLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-form-layout',
                template: "<div class=\"bg-white shadow-sm border border-gray-200 rounded-sm\">\r\n  <div class=\"form-header\">\r\n    <h3 class=\"form-title\">\r\n      {{title}}\r\n    </h3>\r\n    <p class=\"form-subtitle\">\r\n      {{subTitle}}\r\n    </p>\r\n  </div>\r\n  <div class=\"border-t border-gray-200 px-4 py-5 sm:p-0\">\r\n    <div class=\"flex flex-col pt-4\">\r\n      <ng-content></ng-content>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n"
            },] }
];
FormLayoutComponent.ctorParameters = () => [];
FormLayoutComponent.propDecorators = {
    title: [{ type: Input }],
    subTitle: [{ type: Input, args: ['sub-title',] }]
};

class AuthCallbackComponent {
    constructor(authService, router) {
        this.authService = authService;
        this.router = router;
        this.status = 'παρακαλώ περιμένετε...';
    }
    ngOnInit() {
        const self = this;
        this.authService.completeAuthentication().then(() => {
            self.authService.isLoggedIn().subscribe((result) => {
                // i'm sorry!
                if (!result) {
                    self.router.navigate(['/unauthorized']);
                    return;
                }
                // did you want to go somewhere?
                const user = self.authService.currentUser();
                if (user && user.state && user.state.url) {
                    // TODO: should parse this at some point :)
                    // console.log('AuthCallbackComponent user state',user.state);
                    self.router.navigateByUrl('/dashboard');
                    return;
                }
                else {
                    self.router.navigateByUrl('/dashboard');
                    return;
                }
                // lets check your subscriptions...
                // self.status = `we're loading your subscription information, please wait...`;
                //// ok get the subscriptions for the user
                // self.appState.subscriptions.subscribe((subs) => {
                //  self.subscriptions = subs;
                //  if (subs === null || subs.length === 0) {
                //    self.router.navigate(['/new-subscription']);
                //  } else if (subs.length === 1) {
                //    self.status = `welcome ${user.profile.name}, we're loading your configuration information, please wait...`;
                //    self.selectSubscription(subs[0]);
                //  } else {
                //    self.status = `welcome ${user.profile.name}, please select a subscription to proceed...`;
                //  }
                // }, error => {
                //  self.status = `oups! an error occured, sorry about that! please try again in a while :)`;
                // });
            });
        });
    }
}
AuthCallbackComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-auth-callback',
                template: './auth-callback.component.html'
            },] }
];
AuthCallbackComponent.ctorParameters = () => [
    { type: AuthService, decorators: [{ type: Inject, args: [AuthService,] }] },
    { type: Router }
];

class AuthRenewComponent {
    constructor(authService, router) {
        this.authService = authService;
        this.router = router;
    }
    ngOnInit() {
        // console.log('AuthRenewComponent init!!!');
        this.authService.manager.signinSilentCallback().catch(() => {
            // console.log('redirect to unauthorized!');
            this.router.navigate(['/unauthorized']);
        });
    }
}
AuthRenewComponent.decorators = [
    { type: Component, args: [{ selector: 'lib-auth-renew', template: '' },] }
];
AuthRenewComponent.ctorParameters = () => [
    { type: AuthService, decorators: [{ type: Inject, args: [AuthService,] }] },
    { type: Router }
];

class LoggedOutComponent {
    constructor(authService) {
        this.authService = authService;
        this.status = 'working on it, please give me a sec...';
        this.finished = false;
    }
    ngOnInit() {
        this.authService.completeSignout().then(() => {
            this.status = 'Thank you!';
            this.finished = true;
        });
    }
}
LoggedOutComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line:component-selector
                selector: 'lib-logged-out',
                template: "<lib-view-layout title=\"\u03B3\u03B5\u03B9\u03AC \u03C3\u03B1\u03C2!\"></lib-view-layout>\r\n\r\n"
            },] }
];
LoggedOutComponent.ctorParameters = () => [
    { type: AuthService, decorators: [{ type: Inject, args: [AuthService,] }] }
];

class ErrorComponent {
    constructor() {
        this.error = 'Error!';
    }
    ngOnInit() {
    }
}
ErrorComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-error',
                template: "<lib-view-layout [show-header]=\"false\" title=\"500 - \u03C0\u03B1\u03C1\u03BF\u03C5\u03C3\u03B9\u03AC\u03C3\u03C4\u03B7\u03BA\u03B5 \u03C3\u03C6\u03AC\u03BB\u03BC\u03B1!\">\r\n  <div class=\"bg-gray-600 view-container\">\r\n    <div class=\"max-w-2xl mx-auto text-center py-16 px-4 sm:py-20 sm:px-6 lg:px-8\">\r\n      <h2 class=\"text-3xl font-extrabold text-white sm:text-4xl\">\r\n        <span class=\"block\">500</span>\r\n      </h2>\r\n      <p class=\"mt-4 text-lg leading-6 text-gray-200\">\u03C3\u03C6\u03AC\u03BB\u03BC\u03B1, \u03BA\u03B1\u03C4\u03B9 \u03B4\u03B5\u03BD \u03C0\u03AE\u03B3\u03B5 \u03BA\u03B1\u03BB\u03AC...!</p>\r\n      <a href=\"/\" class=\"mt-8 inline-flex items-center justify-center px-5 py-3 border border-transparent text-base font-sm rounded-sm text-gray-600 bg-white hover:bg-gray-50 sm:w-auto\">\r\n        \u03C0\u03B1\u03C4\u03AE\u03C3\u03C4\u03B5 \u03B5\u03B4\u03CE \u03B3\u03B9\u03B1 \u03BD\u03B1 \u03B5\u03C0\u03B9\u03C3\u03C4\u03C1\u03AD\u03C8\u03B5\u03C4\u03B5\r\n      </a>\r\n    </div>\r\n  </div>\r\n</lib-view-layout>\r\n"
            },] }
];

class PageNotFoundComponent {
    constructor() { }
    ngOnInit() {
    }
}
PageNotFoundComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-page-not-found',
                template: "<lib-view-layout [show-header]=\"false\" title=\"404 - \u03B4\u03B5\u03BD \u03B2\u03C1\u03AD\u03B8\u03B7\u03BA\u03B5!\">\r\n<div class=\"bg-gray-600 view-container\">\r\n  <div class=\"max-w-2xl mx-auto text-center py-16 px-4 sm:py-20 sm:px-6 lg:px-8\">\r\n    <h2 class=\"text-3xl font-extrabold text-white sm:text-4xl\">\r\n      <span class=\"block\">404</span>\r\n    </h2>\r\n    <p class=\"mt-4 text-lg leading-6 text-gray-200\">\u03B4\u03B5\u03BD \u03B2\u03C1\u03AD\u03B8\u03B7\u03BA\u03B5 \u03B7 \u03C3\u03B5\u03BB\u03AF\u03B4\u03B1 \u03C0\u03BF\u03C5 \u03B6\u03B7\u03C4\u03AE\u03C3\u03B1\u03C4\u03B5!</p>\r\n    <a href=\"/\" class=\"mt-8 inline-flex items-center justify-center px-5 py-3 border border-transparent text-base font-sm rounded-sm text-gray-600 bg-white hover:bg-gray-50 sm:w-auto\">\r\n      \u03C0\u03B1\u03C4\u03AE\u03C3\u03C4\u03B5 \u03B5\u03B4\u03CE \u03B3\u03B9\u03B1 \u03BD\u03B1 \u03B5\u03C0\u03B9\u03C3\u03C4\u03C1\u03AD\u03C8\u03B5\u03C4\u03B5\r\n    </a>\r\n  </div>\r\n</div>\r\n</lib-view-layout>\r\n"
            },] }
];
PageNotFoundComponent.ctorParameters = () => [];

// tslint:disable-next-line:component-selector
class UnauthorizedComponent {
    constructor(authService) {
        this.authService = authService;
    }
    ngOnInit() {
    }
    signin() {
        this.authService.clearState().then((_) => {
            this.authService.startSignout();
        });
    }
}
UnauthorizedComponent.decorators = [
    { type: Component, args: [{ selector: 'lib-unauthorized', template: "<lib-view-layout [show-header]=\"false\" title=\"401 - \u03B4\u03B5\u03BD \u03B5\u03C0\u03B9\u03C4\u03C1\u03AD\u03C0\u03B5\u03C4\u03B1\u03B9 \u03B7 \u03C0\u03C1\u03CC\u03C3\u03B2\u03B1\u03C3\u03B7!\">\r\n  <div class=\"bg-gray-600 view-container\">\r\n    <div class=\"max-w-2xl mx-auto text-center py-16 px-4 sm:py-20 sm:px-6 lg:px-8\">\r\n      <h2 class=\"text-3xl font-extrabold text-white sm:text-4xl\">\r\n        <span class=\"block\">401</span>\r\n      </h2>\r\n      <p class=\"mt-4 text-lg leading-6 text-gray-200\">\u03B4\u03B5\u03BD \u03AD\u03C7\u03B5\u03C4\u03B5 \u03C4\u03B1 \u03BA\u03B1\u03C4\u03AC\u03BB\u03BB\u03B7\u03BB\u03B1 \u03B4\u03B9\u03BA\u03B1\u03B9\u03CE\u03BC\u03B1\u03C4\u03B1 \u03C0\u03C1\u03CC\u03C3\u03B2\u03B1\u03C3\u03B7\u03C2!</p>\r\n      <a href=\"/\" class=\"mt-8 inline-flex items-center justify-center px-5 py-3 border border-transparent text-base font-sm rounded-sm text-gray-600 bg-white hover:bg-gray-50 sm:w-auto\">\r\n        \u03C0\u03B1\u03C4\u03AE\u03C3\u03C4\u03B5 \u03B5\u03B4\u03CE \u03B3\u03B9\u03B1 \u03BD\u03B1 \u03B5\u03C0\u03B9\u03C3\u03C4\u03C1\u03AD\u03C8\u03B5\u03C4\u03B5\r\n      </a>\r\n    </div>\r\n  </div>\r\n  </lib-view-layout>\r\n\r\n\r\n" },] }
];
UnauthorizedComponent.ctorParameters = () => [
    { type: AuthService, decorators: [{ type: Inject, args: [AuthService,] }] }
];

class AddressPipe {
    transform(value) {
        if (value === undefined) {
            return '';
        }
        // tslint:disable-next-line:no-non-null-assertion
        return `${value.street || ''}${value.streetNumber ? ' ' + value.streetNumber : ''}${value.city ? ', ' + value.city : ''}${+value.postalCode ? ', ' + +value.postalCode : ''}`;
    }
}
AddressPipe.decorators = [
    { type: Pipe, args: [{
                name: 'address',
                pure: false
            },] }
];

class DurationFormatPipe {
    transform(value, arg1, arg2) {
        let days;
        let seconds;
        let minutes;
        let hours;
        if (arg1 === 'ms' && arg2 === 'hhmmss') {
            seconds = Math.floor((value / 1000) % 60);
            minutes = Math.floor(((value / (1000 * 60)) % 60));
            hours = Math.floor((value / (1000 * 60 * 60)));
            return this.format(arg2, seconds, minutes, hours, days);
        }
        else if (arg1 === 's' && arg2 === 'hhmmss') {
            seconds = Math.floor((value % 60));
            minutes = Math.floor(((value / 60) % 60));
            hours = Math.floor(((value / 60) / 60));
            return this.format(arg2, seconds, minutes, hours, days);
        }
        else if (arg1 === 'ms' && (arg2 === 'ddhhmmss' || arg2 === 'ddhhmmssLong')) {
            seconds = Math.floor(((value / 1000) % 60));
            minutes = Math.floor((value / (1000 * 60) % 60));
            hours = Math.floor((value / (1000 * 60 * 60) % 24));
            days = Math.floor((value / (1000 * 60 * 60 * 24)));
            return this.format(arg2, seconds, minutes, hours, days);
        }
        else if (arg1 === 's' && (arg2 === 'ddhhmmss' || arg2 === 'ddhhmmssLong')) {
            seconds = Math.floor(value % 60);
            minutes = Math.floor(((value / 60) % 60));
            hours = Math.floor(((value / 60) / 60) % 24);
            days = Math.floor((((value / 60) / 60) / 24));
            return this.format(arg2, seconds, minutes, hours, days);
        }
        else {
            return value;
        }
    }
    format(arg2, seconds, minutes, hours, days) {
        (days < 10) ? days = '0' + days : days;
        (hours < 10) ? hours = '0' + hours : hours;
        (minutes < 10) ? minutes = '0' + minutes : minutes;
        (seconds < 10) ? seconds = '0' + seconds : seconds;
        switch (arg2) {
            case 'hhmmss':
                return `${hours}:${minutes}:${seconds}`;
            case 'ddhhmmss':
                return `${days}d, ${hours}h, ${minutes}m, ${seconds}s`;
            case 'ddhhmmssLong':
                return `${days} days, ${hours} hours, ${minutes} minutes, ${seconds} seconds`;
        }
        return undefined;
    }
}
DurationFormatPipe.decorators = [
    { type: Pipe, args: [{
                name: 'durationFormat',
                pure: false
            },] }
];

class BaseListComponent {
    constructor(route$, router$) {
        this.route$ = route$;
        this.router$ = router$;
        this.items = null;
        this.view = ListViewType.Tiles;
        this.title = null;
        this.actions = [];
        this.loaderItems = [1, 2, 3, 4, 5];
        this.page = 1;
        this.pageSize = 20;
        this.count = 0;
        this.sort = '';
        this.sortdir = '-';
        this.search = '';
        this.sortOptions = null;
        this.metaItems = [];
    }
    ngOnInit() {
        this.actions = [
            new ViewAction('search', null, null, Icons.Search, 'αναζήτηση'),
            new ViewAction('refresh', null, null, Icons.Refresh, 'ανανέωση στοιχείων')
        ];
        if (this.newItemLink) {
            this.actions.push(new RouterViewAction(Icons.Add, this.newItemLink, 'rightpane', 'προσθήκη νέας εγγραφής;'));
        }
        this.metaItems = [
            { key: 'count', icon: Icons.ItemsCount, text: 'παρακαλώ περιμένετε...' }
        ];
        console.log('base list params init');
        this.route$.queryParams.subscribe(params => {
            console.log('base list params', params);
            if (params.view) {
                this.view = params.view;
            }
            if (params.page) {
                this.page = +params.page;
            }
            if (params.pagesize) {
                this.pageSize = +params.pagesize;
            }
            if (params.search) {
                this.search = params.search;
            }
            if (params.sort) {
                this.sort = params.sort;
            }
            if (params.dir) {
                this.sortdir = params.dir;
            }
            this.load();
        });
        // just to sync params in query
        this.setRouteParams(true);
        // and load data :)
        this.load();
    }
    setRouteParams(locationChange = false) {
        this.router$.navigate([], {
            relativeTo: this.route$, queryParams: {
                view: this.view,
                page: this.page,
                pagesize: this.pageSize,
                search: this.search,
                sort: this.sort,
                dir: this.sortdir
            }, queryParamsHandling: 'merge', skipLocationChange: locationChange
        });
    }
    actionHandler($event) {
        console.log('BaseListComponent actionHandler', $event);
        if ($event.key === 'refresh') {
            this.refresh();
        }
    }
    setView(view) {
        this.view = view;
        this.setRouteParams();
    }
    load() {
        this.count = 0;
        this.items = null;
        this.loadItems().subscribe(result => {
            this.count = result ? result.count : 0;
            this.items = result === null || result === void 0 ? void 0 : result.items;
            this.updateHeaderMeta();
        });
    }
    updateHeaderMeta() {
        var _a;
        const count = (_a = this.metaItems) === null || _a === void 0 ? void 0 : _a.filter(m => m.key === 'count')[0];
        if (count) {
            count.text = `${this.count} αποτελέσματα`;
        }
    }
    refresh() {
        this.count = 0;
        this.page = 1;
        this.items = null;
        this.search = null;
        // https://stackoverflow.com/questions/46213737/angular-append-query-parameters-to-url
        this.setRouteParams();
    }
    pageChanged(page) {
        this.page = page;
        this.setRouteParams();
    }
    pageSizeChanged(pageSize) {
        this.pageSize = pageSize;
        this.page = 1;
        this.setRouteParams();
    }
    sortChanged(sort) {
        console.log('base-list sortChanged', sort);
        this.page = 1;
        this.sort = sort;
        this.setRouteParams();
    }
    sortdirChanged(sortdir) {
        console.log('base-list sortdirChanged', sortdir);
        this.page = 1;
        this.sortdir = sortdir;
        this.setRouteParams();
    }
    searchChanged(searchText) {
        this.search = searchText;
        this.setRouteParams();
    }
}
BaseListComponent.decorators = [
    { type: Component, args: [{ template: '' },] }
];
BaseListComponent.ctorParameters = () => [
    { type: ActivatedRoute },
    { type: Router }
];
class ListViewType {
}
ListViewType.Tiles = 'tiles';
ListViewType.Table = 'table';
ListViewType.Map = 'map';

class IndiceComponentsModule {
}
IndiceComponentsModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    IndiceComponentsComponent,
                    // diectives
                    ClickOutsideDirective,
                    // controls
                    DropDownMenuComponent,
                    PagerComponent,
                    ListViewComponent,
                    ListColumnComponent,
                    ListTileComponent,
                    SkeletonLoaderComponent,
                    // shell layout
                    ShellLayoutComponent,
                    ShellHeaderComponent,
                    ShellFooterComponent,
                    // view layouts
                    ViewLayoutComponent,
                    SideViewLayoutComponent,
                    ModelViewLayoutComponent,
                    FormLayoutComponent,
                    // pages (common)
                    AuthCallbackComponent,
                    AuthRenewComponent,
                    LoggedOutComponent,
                    ErrorComponent,
                    PageNotFoundComponent,
                    UnauthorizedComponent,
                    // pipes
                    AddressPipe,
                    DurationFormatPipe
                ],
                imports: [
                    CommonModule,
                    RouterModule,
                    IndiceAuthModule
                ],
                exports: [
                    IndiceComponentsComponent,
                    ClickOutsideDirective,
                    DropDownMenuComponent,
                    PagerComponent,
                    ListViewComponent,
                    ListColumnComponent,
                    ListTileComponent,
                    SkeletonLoaderComponent,
                    ShellLayoutComponent,
                    ShellHeaderComponent,
                    ShellFooterComponent,
                    ViewLayoutComponent,
                    SideViewLayoutComponent,
                    ModelViewLayoutComponent,
                    FormLayoutComponent,
                    AuthCallbackComponent,
                    AuthRenewComponent,
                    LoggedOutComponent,
                    ErrorComponent,
                    PageNotFoundComponent,
                    UnauthorizedComponent,
                    AddressPipe,
                    DurationFormatPipe
                ]
            },] }
];

/*
 * Public API Surface of indice-components
 */

/**
 * Generated bundle index. Do not edit.
 */

export { APP_LINKS, AddressPipe, AuthCallbackComponent, AuthRenewComponent, BaseListComponent, ClickOutsideDirective, DropDownMenuComponent, DurationFormatPipe, ErrorComponent, ExternalNavLink, FormLayoutComponent, HeaderMetaItem, Icons, IndiceComponentsComponent, IndiceComponentsModule, IndiceComponentsService, ListColumnComponent, ListTileComponent, ListViewComponent, ListViewType, LoggedOutComponent, MenuOption, ModelViewLayoutComponent, NavLink, PageNotFoundComponent, PagerComponent, RouterViewAction, ShellFooterComponent, ShellHeaderComponent, ShellLayoutComponent, SideViewLayoutComponent, SkeletonLoaderComponent, SwitchViewAction, UnauthorizedComponent, ViewAction, ViewLayoutComponent };
//# sourceMappingURL=indice-components.js.map
