import { EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { Router } from '@angular/router';
import { MenuOption } from '../../types';
export declare class PagerComponent implements OnInit, OnChanges {
    private router;
    count: number | null;
    page: number;
    pageSize: number;
    pageSizeOptions: MenuOption[];
    pages: MenuOption[];
    pageChanged: EventEmitter<number>;
    pageSizeChanged: EventEmitter<number>;
    canPreviousPage: boolean;
    canNextPage: boolean;
    sortOptions: MenuOption[];
    sort: string | null;
    sortdir: string | null;
    sortChanged: EventEmitter<string>;
    sortdirChanged: EventEmitter<string>;
    sortdirIcon: string;
    constructor(router: Router);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    private calcPages;
    nextPage(): void;
    previousPage(): void;
    gotoPage(page: number): void;
    pageSizeOptionChanged(pageSize: number): void;
    pageOptionChanged(page: number): void;
    sortOptionChanged(sort: string): void;
    toggleSortdir(): void;
}
