import { Observable } from 'rxjs';
import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { HeaderMetaItem, IResultSet, MenuOption, ViewAction } from '../types';
export declare abstract class BaseListComponent<T> implements OnInit {
    private route$;
    private router$;
    items: T[] | null | undefined;
    view: string;
    title: string | null;
    actions: ViewAction[];
    loaderItems: any[];
    page: number;
    pageSize: number;
    count: number;
    sort: string | null;
    sortdir: string | null;
    search: string | null;
    sortOptions: MenuOption[] | null;
    metaItems: HeaderMetaItem[] | null;
    abstract newItemLink: string | null;
    constructor(route$: ActivatedRoute, router$: Router);
    ngOnInit(): void;
    private setRouteParams;
    actionHandler($event: ViewAction): void;
    setView(view: string): void;
    private load;
    private updateHeaderMeta;
    abstract loadItems(): Observable<IResultSet<T> | null | undefined>;
    refresh(): void;
    pageChanged(page: number): void;
    pageSizeChanged(pageSize: number): void;
    sortChanged(sort: string): void;
    sortdirChanged(sortdir: string): void;
    searchChanged(searchText: string | null): void;
}
export declare class ListViewType {
    static Tiles: string;
    static Table: string;
    static Map: string;
}
