export interface IAppLinks {
    public: NavLink[];
    main: NavLink[];
    profile: NavLink[];
    profileActions: NavLink[];
    legal: NavLink[];
    brand: NavLink[];
}
export declare class NavLink {
    constructor(text: string, path: string, exact?: boolean, external?: boolean, icon?: string);
    text: string;
    path: string;
    exact: boolean;
    external: boolean;
    icon: string | undefined;
}
export declare class ExternalNavLink extends NavLink {
    constructor(text: string, path: string, icon?: string);
}
export declare class ViewAction {
    type: string;
    key: string | null;
    param: any;
    icon: string;
    tooltip: string | null;
    constructor(type: string, key: string | null, param: any, icon: string, tooltip: string | null);
}
export declare class RouterViewAction extends ViewAction {
    outlet: string | null;
    link: string | null;
    constructor(icon: string, link: string, outlet: string | null, tooltip: string | null);
}
export declare class SwitchViewAction extends ViewAction {
    constructor(view: string, icon: string, tooltip: string | null);
}
export interface IResultSet<T> {
    count: number;
    items: T[];
}
export declare class HeaderMetaItem {
    key: string | null;
    icon: string | null;
    text: string | null;
}
export declare class MenuOption {
    constructor(text: string, value: any);
    text: string;
    value: any;
}
export interface IAddress {
    id?: string;
    street?: string | null;
    streetNumber?: string | null;
    city?: string | null;
    region?: string | null;
    postalCode?: string | null;
}
